<?php
/*
Plugin Name: Next to Last
Version: 0.1 2004-06-28
Plugin URI: http://thunkgeek.com/wordpress-plugins.php
Description: This plugin adds "<< last post" and "next post >>" links to the top left and bottom left corners of the edit screen, allowing the user to easily move back and forth between Wordpress posts. The links at the bottom of the screen attempt to always bring the user back to the bottom of the screen to allow rapid viewing of post previews to facilitate spell checking, etc. If it works well for you, or poorly, or whatever, please leave a comment at <a href="http://thunkgeek.com/wordpress-plugins.php">http://thunkgeek.com/wordpress-plugins.php</a>
Author: Adam Bayless
Author URI: http://thunkgeek.com/
*/ 

/*
Next to Last Plugin for Wordpress 1.2
Copyright (C) 2004 Adam Bayless

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
*/

// Setup a div at the top of the page to hold the links. We can't put them directly in
// because we don't have the post_ID variable yet.
function ntl_insert_div() {
        if (!strstr($_SERVER['PHP_SELF'], 'post.php'))
		return 0;
	print '<div id="ntllinks"></div>';
}

// Replace the text at the top of the screen using javascript and add the links at the bottom of
// the screen. There is probably a more elegant way to do this but I haven't found it yet and
// at least this works pretty well. In a future version I need to add a call to the DB to see if
// the next and last posts really exist so the user doesn't get errors on the page. I do at least
// check to see if we are at zero and don't print a "last post" link in that case.
function ntl_reset_links($postId) {
        global $post_ID;
	if (!strstr($_SERVER['PHP_SELF'], 'post.php')) 
		return 0;
	print '<script language="javascript"> ';
	print 'document.getElementById("ntllinks").innerHTML = "';
	if ($post_ID > 1) print '<a href=\'post.php?action=edit&post=' . ($post_ID - 1) . '\'><< last post</a> | ';
	else print '<< last post | ';
	print '<a href=\'#preview\'> preview |';
	print '<a href=\'post.php?action=edit&post=' . ($post_ID + 1) . '\'> next post >></a>" '; 
	print '</script>';
	print '<a name="nlp_bottom">';
	if ($post_ID > 1) print '<a href=\'post.php?action=edit&post=' . ($post_ID - 1) . '#preview\'><< last post</a> | ';
	else print '<< last post | ';
	print '<a href=\'#ntllinks\'> top |';
	print '<a href=\'post.php?action=edit&post=' . ($post_ID + 1) . '#preview\'> next post >></a> ';
}

// Call the functions
add_action('admin_head', 'ntl_insert_div');
add_action('admin_footer', 'ntl_reset_links');

?>
